using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Management;


namespace RestOff
{
    public partial class MainForm : Form
    {
        private const int DEFAULT_COUNT = 30;
        private const int DEFAULT_CPU = 50;
        private const string WAIT_MSG = "^C}[͒~ł";
        private int mCount;
        private bool mIsCountingDown = false;
        private bool mStartedTimer = false;

        public MainForm()
        {
            InitializeComponent();
        }

        /// <summary>
        /// ԊuƂɎsobNOEhXbh̏
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>tH[̃Xbhł͂Ȃ̂ŁAtH[𑀍삵Ă͂Ȃ</remarks>
        private void bgWorker_DoWork(object sender, DoWorkEventArgs e)
        {
            double per = 0;
            do
            {
                per = pfCpu.NextValue();
                bgWorker.ReportProgress((int)per);
                System.Threading.Thread.Sleep(1000);
                //LZǍCPU̎gp͏펞\Ă̂ŉiɃ[v
                if (bgWorker.CancellationPending==true)
                {
                    return;
                }
            } while (true);
        }

        /// <summary>
        /// ԊuƂɃR[obN郁\bh(Cxg)
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>ReportProgressɂĔCxg</remarks>
        private void bgWorker_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            //ʕ\
            int cpu;
            if (int.TryParse(txtCpu.Text, out cpu) == false)
            {
                txtCpu.Text = DEFAULT_CPU.ToString();
                cpu = DEFAULT_CPU;
            }

            int per = (int)e.ProgressPercentage;
            prbCpu.Value = per;

            lblCpuPer.Text = string.Format("{0} %", per);

            JudgeSuspend(cpu, per);

        }

        /// <summary>
        /// x~[hڍsւ̔
        /// </summary>
        /// <param name="cpu"></param>
        /// <param name="per"></param>
        private void JudgeSuspend(int cpu, int per)
        {
            //^C}[oĂȂ΂̂܂ܔ
            if (mStartedTimer == false) return;

            if (per < cpu)
            {
                if (mIsCountingDown == true)
                {
                    mCount -= 1;
                    lblCount.Text = string.Format("{0}bɋx~[hɂȂ܂", mCount);
                }
                mIsCountingDown = true;
            }
            else
            {
                mIsCountingDown = false;
                lblCount.Text = string.Format("CPUgp̂ŃJEg_E~ł", mCount);
                ResetCounter();
            }


            //x~[hڍs
            if (mCount == 0)
            {
                StopTimer();
                //x~[h
                Application.SetSuspendState(PowerState.Hibernate, false, false);
            }
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            StartTimer();
        }

        /// <summary>
        /// ^C}[X^[g
        /// </summary>
        private void StartTimer()
        {
            btnStart.Enabled = false;
            btnStop.Enabled = true;
            mStartedTimer = true;
            ResetCounter();            
        }

        private void btnStop_Click(object sender, EventArgs e)
        {
            StopTimer();
        }

        /// <summary>
        /// ^C}[Xgbv
        /// </summary>
        private void StopTimer()
        {
            btnStart.Enabled = true;
            btnStop.Enabled = false;
            mStartedTimer = false;
            ResetCounter();
            lblCount.Text = WAIT_MSG;
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            txtWait.Text = DEFAULT_COUNT.ToString();
            StopTimer();
            bgWorker.RunWorkerAsync();
        }

        /// <summary>
        /// JEg_E^C}[Zbg
        /// </summary>
        private void ResetCounter()
        {
            if (int.TryParse(txtWait.Text, out mCount) == false)
            {
                mCount = DEFAULT_COUNT;
                txtWait.Text = mCount.ToString();
            }

        }
    }
}